import pandas as pd
from backtesting import BackTesting


class Factoring(BackTesting):

    def __init__(self, period=5):
        super(Factoring, self).__init__()
        self.period = period
        self.stock_scores = pd.Series()
        self.factors = [self.factor_zero]

    def score(self):
        final_score = pd.Series(index=self.stocks.index, data=0)
        for f in self.factors:
            s = f()  # get scores
            final_score += s

    def choose(self):
        self.score()
        self.stock_scores.sort_values(ascending=False, inplace=True)
        return self.stock_scores.head().index

    def factor_zero(self):
        return pd.Series(index=self.stocks.index, data=0)

    def make(self):
        if self.i_days % self.period != 0:  # just stop loss
            super(Factoring, self).make()
        else:  # adjusting
            target = self.choose()
            origin = self.stocks.index
            for ticker in set(target) - set(origin):  # add new
                self.stocks[ticker] = 0

            self.throwing = pd.Series(list(set(origin) - set(target)))
