#!/usr/bin/env python3
import pandas as pd

from backtesting import BackTesting
import stoploss
import factoring


class PlainBuying(BackTesting):
    start_iloc = 0

    def __init__(self, start_iloc=0, *args, **kwargs):
        super(PlainBuying, self).__init__(*args, **kwargs)
        self.start_iloc = start_iloc

    def init(self):
        super(PlainBuying, self).init()
        n = len(self.stocks)
        self.amount_yesterday = self.cash
        self.buying = pd.Series(index=self.stocks.index, data=[self.cash / n] * n)

        self.iter_data = self.iter_data.iloc[self.start_iloc:]

        i, row = next(iter(enumerate(self.rows())))
        self.i_days = i
        self.parse_line(row)
        self.trade()  # buy the etfs and skip others
        self.record()

    def morning(self):
        super(PlainBuying, self).morning()
        self.skip_trade = True  # we do not need to trade
        return True

    def night(self):
        self.commission_today = 0
        return True


StopLoss = stoploss.Robust

Robust = stoploss.Robust


class Hybrid(StopLoss, factoring.Factoring):

    def __init__(self):
        super(Hybrid, self).__init__()
